program scatter_gather
      !USE MPI
      implicit none
      include "mpif.h"

      integer ierr, myid, nprocs

      integer i,cnt
      parameter (cnt = 10)
      integer initvec(100),buf_data(cnt)

      real*8 f,sum,mysum
      real*8 xmin,xmax,x

      call MPI_INIT(ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, myid, ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, nprocs, ierr)

      
      if (myid .eq. 0) then
         do i=1,nprocs*cnt
         initvec(i)=int(1000.0*rand())
         write(6,*) myid,nprocs,i, initvec(i)
         enddo
      endif

        call MPI_SCATTER(initvec,cnt,MPI_INTEGER,buf_data,cnt,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)

      do i=1,cnt
         buf_data(i) = 2*buf_data(i)
      enddo

        call MPI_GATHER(buf_data,cnt,MPI_INTEGER,initvec,cnt,MPI_INTEGER,0,MPI_COMM_WORLD,ierr)

      if (myid .eq. 0) then
         do i=1,nprocs*cnt
         write(6,*) myid,nprocs,i, initvec(i)
         enddo
      endif

      call MPI_FINALIZE(ierr)

      stop
      end 
