!Thu Oct 22 15:51:20 CEST 2015
!Written by Pedro Ojeda
program main
      use MPI 
      integer :: ierr,rank,size
      integer :: request,status(MPI_STATUS_SIZE)
      integer,parameter :: num_elem=100000
      integer :: a(num_elem),b(num_elem)

      call MPI_INIT( ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, rank, ierr)
      call MPI_COMM_SIZE( MPI_COMM_WORLD, size, ierr)

!Non-blocking routines for sending/receving to avoid dead-lock
      if(rank == 0) then
              do i=1,num_elem
                  a(i)=i
                  b(i)=2*i
              enddo
              write(6,10) 'rank 0 a',(a(i),i=1,10)
              write(6,10) 'rank 0 b',(b(i),i=1,10)
              call MPI_ISEND(a,num_elem,MPI_INT,1,1,MPI_COMM_WORLD,request,ierr)
              call MPI_ISEND(b,num_elem,MPI_INT,1,2,MPI_COMM_WORLD,request,ierr)
      elseif(rank ==1) then
              call MPI_IRECV(b,num_elem,MPI_INT,0,2,MPI_COMM_WORLD,request,ierr)
              call MPI_WAIT(request, status, ierror)
              write(6,10) 'rank 1 b',(b(i),i=1,10)
              call MPI_IRECV(a,num_elem,MPI_INT,0,1,MPI_COMM_WORLD,request,ierr)
              call MPI_WAIT(request, status, ierror)
              write(6,10) 'rank 1 a',(a(i),i=1,10)
      else 
          print *, 'no other task'

      endif

10    format(A12,10I7)
      call MPI_FINALIZE( ierr )

end
