program main
      use MPI 
      integer :: ierr,rank,size
      integer :: trans
      integer :: status(MPI_STATUS_SIZE)

      call MPI_INIT( ierr )
      call MPI_COMM_RANK( MPI_COMM_WORLD, rank, ierr)
      call MPI_COMM_SIZE( MPI_COMM_WORLD, size, ierr)


      if(rank .ne. 0) then
              call MPI_RECV(trans,1,MPI_INT,rank-1,0,MPI_COMM_WORLD,status,ierr)
              write(6,*) 'Process',rank,'received token',trans,'from process',rank-1
      else 
          trans=-1
      endif

              call MPI_SEND(trans,1,MPI_INT,mod(rank+1,size),0,MPI_COMM_WORLD,ierr)

      if(rank .eq. 0) then
              call MPI_RECV(trans,1,MPI_INT,rank-1,0,MPI_COMM_WORLD,status,ierr)
              write(6,*) 'Process',rank,'received token',trans,'from process',size-1
      endif

      call MPI_FINALIZE( ierr )

end
